#!/usr/bin/env python

#
#Copyrigt (c) 2008
#		Matt Smith <melkor@orangepalantir.org>
#
#This file is part of GraphCutie,This file is part of Foobar.
#
#GraphCutie is free software: you can redistribute it and/or modify
#it under the terms of the GNU General Public License as published by
#the Free Software Foundation, either version 3 of the License, or
#(at your option) any later version.
#
#GraphCutie is distributed in the hope that it will be useful,
#but WITHOUT ANY WARRANTY; without even the implied warranty of
#MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#GNU General Public License for more details.
#
#You should have received a copy of the GNU General Public License
#along with GraphCutie, in the file COPYING.  
#If not, see <http://www.gnu.org/licenses/>.
#
#GraphCutie uses both python and PyQT, GPL version.  The copyright notices
#can be found in copyright_notice.txt


""" This module is to be used by the calculator class.  The only thing it does is call Operations"""

from Calculator import FUNCTIONS,VARIABLES,PM,OPERATORS
import sys
def Operations(term_list):
	"""Main function, this will take a list of strings that represent operators,floats, 
	variables and functions then change then caclulate this list as a mathematical expression.  
	It works as as stack type system in that it goes to the bottom of a stack and evaluates the 
	number then moves up."""
	
	term_list = ParseFunctions(term_list)
	#exponents
	edex = OpIndex('^',term_list)
	while edex>0:
		edex,a = ForwardBack(term_list,edex,'^')
	#multiply and divide
	mdex = OpIndex('*',term_list)
	ddex = OpIndex('/',term_list)
	while mdex>0 or ddex>0:
		if 0<mdex and (mdex < ddex or ddex<0):
			mdex,a = ForwardBack(term_list,mdex,'*')
			ddex = ddex - a
		elif 0<ddex and (ddex<mdex or mdex<0):
			ddex, a = ForwardBack(term_list,ddex,'/')
			mdex = mdex - a
	#add and subtract
	adex = OpIndex('+',term_list)
	sdex = OpIndex('-',term_list)
	while adex>=0 or sdex>=0:
		if 0<=adex and (adex < sdex or sdex<0):
			adex,a = ForwardBack(term_list,adex,'+')
			sdex = sdex - a
		elif 0<=sdex and (sdex<adex or adex<0):
			sdex,a = ForwardBack(term_list,sdex,'-')
			adex = adex - a
	if len(term_list)>1:
		raise ValueError("Calculation not complete %s"%term_list)
	else:
		return Evaluate(term_list[0])

def OpIndex(op,mylist,last=0):
	"""get the next index of any operator in the list"""
	try:
		return mylist.index(op,last)
	except:
		return -1

def ForwardBack(worklist,index,op):
	"""this function finds the forward value and the backward value then returns the 
	size of slize and the value of the new index"""
	if index>0:
		previous = Evaluate(worklist[index-1])
		b = 0
	else:
		previous = 0.
		b = 1
	try:
		 worklist[index + 1]
	except IndexError,e:
		raise IndexError(str(worklist[index]))
	if type(worklist[index + 1])!=list and worklist[index+1] in PM:
		next = PM.get(worklist[index + 1])(Evaluate(worklist[index+2]))
		a = 3
	else:
		next= Evaluate(worklist[index + 1])
		a = 2
	replacement = OPERATORS.get(op)(previous,next)
	first_index = index -1 + b
	second_index = index + a
	worklist[first_index:second_index] = [replacement]
	ndex = OpIndex(op,worklist,index)
	slice_size = second_index - first_index
	return ndex,slice_size-1

def ParseFunctions(term_list):
	"""This looks for functions in the FUNCTIONS dictionary  """
	i = 0
	while i < len(term_list):
		if type(term_list[i]) != list and term_list[i] in FUNCTIONS:
			myfunct = FUNCTIONS.get(term_list[i])
			myvar = Evaluate(term_list[i+1])
			term_list[i:i+2] = [myfunct(myvar)]
		else:
			i += 1
	return term_list

def Evaluate(term_item):
	"""a heavily abused function, it evaluats the items"""
	if type(term_item)==list:
		return Operations(term_item)
	elif term_item in VARIABLES:
		return VARIABLES.get(term_item)
	else:
		try:
			return float(term_item)
		except:
			raise ValueError(term_item)

