#!/usr/bin/env python

#
#Copyrigt (c) 2008
#		Matt Smith <melkor@orangepalantir.org>
#
#This file is part of GraphCutie,This file is part of Foobar.
#
#GraphCutie is free software: you can redistribute it and/or modify
#it under the terms of the GNU General Public License as published by
#the Free Software Foundation, either version 3 of the License, or
#(at your option) any later version.
#
#GraphCutie is distributed in the hope that it will be useful,
#but WITHOUT ANY WARRANTY; without even the implied warranty of
#MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#GNU General Public License for more details.
#
#You should have received a copy of the GNU General Public License
#along with GraphCutie, in the file COPYING.  
#If not, see <http://www.gnu.org/licenses/>.
#
#GraphCutie uses both python and PyQT, GPL version.  The copyright notices
#can be found in copyright_notice.txt


"""For the best implementation of this use the Calculator Class, which calls the function parse.
These are all of the tools nescessary to parse a mathematical expression the main use for this is:
	PreParse(rawstring)
	modstring = SecondParse(rawstring)
	firstlist = Parenthesis(modstring)
	stacklist = Operator(firstlist)
	
	Stack list will be a prepared list of strings for the Evaluate.py module to finish."""

from Calculator import OPERATORS,INTS,PM

def PreParse(rawstring):
	"""This checks for equal signs and parenthesis errors, no modifications"""
	if rawstring.count('(') != rawstring.count(')'):
		raise SyntaxError("Parenthesis do not Match")
	if rawstring.count('=')>1:
		raise SyntaxError("Invalid Assignment Unequal Parenthesis")
	return 0

def SecondParse(rawstring):
	"""Removes spaces and changes ** to single characters ^ and multiplies out all of the +- pairs to leave the string with only single operators left"""
	newstring = rawstring.replace(' ','')
	newstring = newstring.replace('**','^')
	u = True
	while u:
		u = False
		if '--' in newstring:
			newstring = newstring.replace('--','+')
			u = True
		if '-+' in newstring:
			newstring = newstring.replace('-+','-')
			u = True
		if '+-' in newstring:
			newstring =newstring.replace('+-','-')
			u = True
		if '++' in newstring:
			newstring = newstring.replace('++','+')
			u = True
		return newstring

def Parenthesis(str_exp,OPEN='(',CLOSE=')'):
	"""
	This function expects ready to go, parenthesis laden functions as strings,preparsing should be done before hand.
	some examples;
	 a + b becomes ['a + b']
	(a+b) becomes [['a + b']]
	(a + b)*(c + d) becomes a list of [['a+b'],'*',['c+d']]
	also (a *(b+c))*(a + b) becomes a list [['a*',['b+c']],'*',['a + b']]
	"""
	output = []
	nowstring = ''
	i = 0
	while i<len(str_exp):
		if str_exp[i]==OPEN:
			output.append(nowstring)
			nowstring = ''
			newexpression,ichange = Parenthesis(str_exp[i+1:])
			i += ichange + 1
			output.append(newexpression)
		elif str_exp[i]==CLOSE:
			output.append(nowstring)
			nowstring = ''
			return output,i
		else:
			nowstring += str_exp[i]
		i += 1
	if len(nowstring)>0:
		output.append(nowstring)
	return output

def Operators(list_expressions):
	"""
	this breaks the list of expressions further into operators and terms.  It works recursively.
	This function expects that white space has already been removed.
	"""
	list_terms = []
	for item in list_expressions:
		if type(item)==list:
			list_terms.append(Operators(item))
		else:
			one_term = ''
			for char in item:
				if char in OPERATORS and CheckFloat(one_term,char):
					sone_term = one_term
					if len(sone_term)>0:
						list_terms.append(sone_term)
					list_terms.append(char)
					one_term = ''
				else:
					one_term += char
			sone_term = one_term.strip()
			if len(sone_term)>0:
				list_terms.append(sone_term)
	return list_terms

def CheckFloat(ot,op):
	"""This tries to catch a float"""
	try:
		last = ot[-1]
	except:
		return True
	if op in PM and last=='e':
		return False
	else:
		return True
def Parse(rawstring):
	"""This function does everything parses a string to a stacklist"""
	PreParse(rawstring)
	modstring = SecondParse(rawstring)
	firstlist = Parenthesis(modstring)
	stacklist = Operators(firstlist)
	return stacklist