#!/usr/bin/env python

#
#Copyrigt (c) 2008
#		Matt Smith <melkor@orangepalantir.org>
#
#This file is part of GraphCutie,This file is part of Foobar.
#
#GraphCutie is free software: you can redistribute it and/or modify
#it under the terms of the GNU General Public License as published by
#the Free Software Foundation, either version 3 of the License, or
#(at your option) any later version.
#
#GraphCutie is distributed in the hope that it will be useful,
#but WITHOUT ANY WARRANTY; without even the implied warranty of
#MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#GNU General Public License for more details.
#
#You should have received a copy of the GNU General Public License
#along with GraphCutie, in the file COPYING.  
#If not, see <http://www.gnu.org/licenses/>.
#
#GraphCutie uses both python and PyQT, GPL version.  The copyright notices
#can be found in copyright_notice.txt


try:
	from PyQt4 import QtGui,QtCore,QtSvg
except:
	print "you need PyQt4 to use this application as a python script"
import sys,os
from Calculator import OPERATORS

class GuiCalc(QtGui.QWidget):
	"""This is a graphical interface to the Calculator module.  Commands are executd  """
	def __init__(self,parent=None):
		QtGui.QWidget.__init__(self,parent)
		try:
			self.cc = parent.Calculator
		except:
			self.cc=Calculator()
		self.Stack = []
		self.Input = MyQCombo(self)
		self.Display = QtGui.QTextEdit(self)
		self.Display.setReadOnly(True)
		self.Display.setFontPointSize(12)
		self.Script = []
		layout = QtGui.QVBoxLayout()
		layout.addWidget(self.Display)
		layout.addWidget(self.Input)
		self.connect(self.Input,QtCore.SIGNAL("Calculate ( QString )"),self.ExecScriptCmd)
		self.setContentsMargins(30,30,30,30)
		self.setLayout(layout)
	def ErrorMessage(self,em):
		self.Display.setTextColor(QtGui.QColor('Red'))
		self.Display.append("%s\n"%em)
	def ExecScriptCmd(self,command):
		check,result = self.cc.FromExpression(str(command))
		self.Display.setTextColor(QtGui.QColor('blue'))
		self.Display.setAlignment(QtCore.Qt.AlignLeft)
		self.Display.append(" expr: %s\n"%command)
		if check:
			self.Display.setAlignment(QtCore.Qt.AlignCenter)
			self.Display.setTextColor(QtGui.QColor('black'))
			self.Display.append("%s\n"%result)
			self.Script.append(command)
			if '=' not in str(command):
				self.Input.ConnectPrevious()
		else:
			self.Display.setTextColor(QtGui.QColor('Red'))
			self.Display.append("%s\n"%result)

class MyQCombo(QtGui.QComboBox):
	def __init__(self,parent=None):
		QtGui.QComboBox.__init__(self,parent)
		self.setEditable(True)
		self.setDuplicatesEnabled(True)
		self.setInsertPolicy(QtGui.QComboBox.NoInsert)
		self.setAutoCompletion(False)
		self.addItem("")
		self.addPrevious = False
		self.connect(self,QtCore.SIGNAL("activated (const QString&)"),QtCore.SLOT("setEditText(const QString&)"))
		self.connect(self.lineEdit(),QtCore.SIGNAL("returnPressed ()"),self.HardReturn)
		mf = self.lineEdit().font()
		mf.setPointSize(14)
		self.setFixedHeight(35)
		self.last = ''
	def HardReturn(self):
		self.last = self.currentText()
		self.insertItem(self.count()-1,self.currentText())
		self.setCurrentIndex(self.count()-1)
		self.clearEditText()
		self.emit(QtCore.SIGNAL("Calculate ( QString )"),self.last)
	def ConnectPrevious(self):
		"""automatically puts the previous value in if you start with an operator"""
		self.connect(self.lineEdit(),QtCore.SIGNAL("textChanged( QString )"),self.InsertPrevious)
	def DisconnectPrevious(self):
		"""makes it stop checking"""
		self.disconnect(self.lineEdit(),QtCore.SIGNAL("textChanged( QString )"),self.InsertPrevious)
	def InsertPrevious(self,ct):
		"""the routine that checks if the new value is an operator"""
		self.DisconnectPrevious()
		if str(ct) in OPERATORS:
			self.lineEdit().setText("ans%s"%ct)
