#!/usr/bin/env python

#
#Copyrigt (c) 2008
#		Matt Smith <melkor@orangepalantir.org>
#
#This file is part of GraphCutie,This file is part of Foobar.
#
#GraphCutie is free software: you can redistribute it and/or modify
#it under the terms of the GNU General Public License as published by
#the Free Software Foundation, either version 3 of the License, or
#(at your option) any later version.
#
#GraphCutie is distributed in the hope that it will be useful,
#but WITHOUT ANY WARRANTY; without even the implied warranty of
#MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#GNU General Public License for more details.
#
#You should have received a copy of the GNU General Public License
#along with GraphCutie, in the file COPYING.  
#If not, see <http://www.gnu.org/licenses/>.
#
#GraphCutie uses both python and PyQT, GPL version.  The copyright notices
#can be found in copyright_notice.txt


try:
	from PyQt4 import QtGui,QtCore,QtSvg
except:
	print "you need PyQt4 to use this application as a python script"
import sys,os

class WinConfigWidget(QtGui.QWidget):
	def __init__(self,parent=None):
		QtGui.QWidget.__init__(self,parent)
		calc = parent.Calculator
		layout = QtGui.QVBoxLayout()
		
		sublayout = QtGui.QHBoxLayout()
		sublayout.addWidget(QtGui.QLabel("Number Format",self))
		self.DType = QtGui.QComboBox(self)
		self.DType.addItems(["Decimal Notation","Scientific Notation"])
		self.connect(self.DType, QtCore.SIGNAL("activated( int )"), calc.SetDType)
		self.DType.setCurrentIndex(1)
		calc.SetDType(1)
		sublayout.addWidget(self.DType)
		layout.addLayout(sublayout)
		
		sublayout = QtGui.QHBoxLayout()
		sublayout.addWidget(QtGui.QLabel("Precision:"))
		self.Precision = QtGui.QSpinBox(self)
		self.Precision.setMinimum(0)
		self.Precision.setMaximum(50)
		self.Precision.setValue(6)
		self.connect(self.Precision, QtCore.SIGNAL("valueChanged( int )"), calc.SetPrecision)
		
		sublayout.addWidget(self.Precision)
		layout.addLayout(sublayout)
		
		self.StepNumber = NameBlocks("Number of Steps","1000",self)
		self.connect(self.StepNumber.A,QtCore.SIGNAL("editingFinished()"),self.StepCheck)
		parent.MainPlot.Graph.connect(self,QtCore.SIGNAL("setSteps(int)"), parent.MainPlot.Graph.SetSteps)
		layout.addWidget(self.StepNumber)
		layout.addStretch()
		self.setLayout(layout)
	def StepCheck(self):
		steps = self.StepNumber.Value()
		try:
			ns = int(steps)
		except:
			pass
		else:
			if ns>1 and ns<10000:
				self.emit(QtCore.SIGNAL("setSteps( int )"),ns)
				return None
		self.StepNumber.Error()
		print "not valid"
		

class PlotConfigWidget(QtGui.QWidget):
	def __init__(self,parent=None):
		QtGui.QWidget.__init__(self,parent)
		layout = QtGui.QVBoxLayout()
		self.Xmin = NameBlocks("Xmin","-10",self)
		self.Xmax = NameBlocks("Xmax","10",self)
		self.Ymin = NameBlocks("Ymin","-1",self)
		self.Ymax = NameBlocks("Ymax","1",self)
		self.Auto = QtGui.QCheckBox("Auto Scale Yaxis",self)
		self.Auto.setChecked(True)
		layout.addWidget(self.Xmin)
		layout.addWidget(self.Xmax)
		layout.addWidget(self.Auto)
		layout.addWidget(self.Ymin)
		layout.addWidget(self.Ymax)
		
		layout.addStretch()
		self.setLayout(layout)
	def Report(self):
		return (	float(self.Xmin.Value()),
				float(self.Xmax.Value()),
				float(self.Ymin.Value()),
				float(self.Ymax.Value()),
				self.Auto.isChecked())
class NameBlocks(QtGui.QWidget):
	""" This is a stacked widget with two widgets inside, a label and a lineedit """
	def __init__(self,stext1,stext2,parent=None):
		QtGui.QWidget.__init__(self,parent)
		self.setFixedHeight(40)
		self.A = QtGui.QStackedWidget(self)
		self.A.setFixedHeight(24)
		layout = QtGui.QHBoxLayout()
		layout.addWidget(QtGui.QLabel(stext1,self))
		layout.addStretch()
		layout.addWidget(self.A)
		tlabel = ELabel("%s"%stext2,self)
		tlabel.setFrameStyle(QtGui.QFrame.StyledPanel | QtGui.QFrame.Sunken)
		tedit = QtGui.QLineEdit(self)
		tedit.setText('%s'%stext2)
		self.A.connect(tedit,QtCore.SIGNAL("editingFinished ()"),self.FixMe)
		self.A.connect(tlabel,QtCore.SIGNAL("clicked()"),self.EditMe)
		self.A.addWidget(tlabel)
		self.A.addWidget(tedit)
		self.A.setCurrentIndex(0)
		self.A.setAutoFillBackground(True)
		self.setLayout(layout)
	def EditMe(self):
		"""changes the value of the label to the lineedit and changes back to a label"""
		self.A.setCurrentIndex(1)
		return None
	def FixMe(self):
		"""set value of label to line edit and switch back"""
		self.A.widget(0).setText(self.A.widget(1).text())
		self.A.setCurrentIndex(0)
		self.A.widget(1).setPalette(self.palette())
		self.A.emit(QtCore.SIGNAL("editingFinished()"))
		return None
	def Value(self):
		return str(self.A.widget(0).text())
	
	def Error(self):
		self.A.setCurrentIndex(1)
		self.A.widget(1).palette().setColor(QtGui.QPalette.Base,QtGui.QColor('red'))

class ELabel(QtGui.QLabel):
	def __init__(self,stext,parent=None):
		QtGui.QLabel.__init__(self,stext,parent)
	def mousePressEvent(self,e):
		self.emit(QtCore.SIGNAL("clicked()"))
